#include <iostream>
using namespace std;

class State;

class Context {
public:
    Context();
	~Context();
	void change();
	string getColor();
	void setState(State* state);
		
  protected:
    Context(State* state_);
	State* getState();
  private: 
    State* state;
};

class State {
  public:
    virtual void handleChange(Context* c) = 0;
    virtual string getColor() = 0;
};

class RedState : public State {
  public:
    virtual void handleChange(Context* c);
    virtual string getColor();
};

class GreenState : public State {
  public:
    virtual void handleChange(Context* c);
    virtual string getColor();
};

class AmberState : public State {
  public:
    virtual void handleChange(Context* c);
    virtual string getColor();
};

Context::Context() {
    this->state = new RedState();
}

Context::~Context() {
    delete this->state;
}

Context::Context(State* state_) {
    this->state = state_;
}


State* Context::getState() {
    return state;
}

void Context::setState(class State* state) {
    delete this->state;
    this->state = state;
}

void Context::change() {
    state->handleChange(this);
}

string Context::getColor() {
    return state->getColor();
}

void RedState::handleChange(Context* c) {
    c->setState(new GreenState());
}

string RedState::getColor() {
    return "Red";
}

void AmberState::handleChange(Context* c) {
    c->setState(new RedState());
}

string AmberState::getColor() {
    return "Amber";
}

void GreenState::handleChange(Context* c) {
    c->setState(new AmberState());
}

string GreenState::getColor() {
    return "Green";
}

int main(){
    Context* context = new Context();
    for (int i = 0; i < 10; i++) {
        cout << "Traffic light is currently: " << context->getColor() << endl;
        context->change();
    }
    delete context;
    return 0; 
}
